diff --git a/examples/Makefile.am b/examples/Makefile.am
index c0d84eb..96112e7 100644
--- a/examples/Makefile.am
+++ b/examples/Makefile.am
@@ -30,7 +30,10 @@ check_PROGRAMS = nft-table-add		\
 		 nft-flowtable-get	\
 		 nft-ruleset-get	\
 		 nft-ruleset-parse-file	\
-		 nft-compat-get
+		 nft-compat-get 	\
+		 nft-ct-helper-add	\
+		 nft-ct-helper-get	\
+		 nft-ct-helper-del
 
 nft_table_add_SOURCES = nft-table-add.c
 nft_table_add_LDADD = ../src/libnftnl.la ${LIBMNL_LIBS}
@@ -124,3 +127,12 @@ nft_ruleset_parse_file_LDADD = ../src/libnftnl.la ${LIBMNL_LIBS}
 
 nft_compat_get_SOURCES = nft-compat-get.c
 nft_compat_get_LDADD = ../src/libnftnl.la ${LIBMNL_LIBS}
+
+nft_ct_helper_add_SOURCES = nft-ct-helper-add.c
+nft_ct_helper_add_LDADD = ../src/libnftnl.la ${LIBMNL_LIBS}
+
+nft_ct_helper_get_SOURCES = nft-ct-helper-get.c
+nft_ct_helper_get_LDADD = ../src/libnftnl.la ${LIBMNL_LIBS}
+
+nft_ct_helper_del_SOURCES = nft-ct-helper-del.c
+nft_ct_helper_del_LDADD = ../src/libnftnl.la ${LIBMNL_LIBS}
diff --git a/examples/nft-ct-helper-add.c b/examples/nft-ct-helper-add.c
new file mode 100644
index 0000000..397443b
--- /dev/null
+++ b/examples/nft-ct-helper-add.c
@@ -0,0 +1,149 @@
+/*
+ * (C) 2012-2016 by Pablo Neira Ayuso <pablo@netfilter.org>
+ *
+ * This program is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ */
+
+#include <stdlib.h>
+#include <string.h>
+#include <time.h>
+#include <netinet/in.h>
+
+#include <linux/netfilter.h>
+#include <linux/netfilter/nf_tables.h>
+
+#include <libmnl/libmnl.h>
+#include <libnftnl/object.h>
+
+static uint16_t parse_family(char *str, const char *option)
+{
+        if (strcmp(str, "ip") == 0)
+                return NFPROTO_IPV4;
+        else if (strcmp(str, "ip6") == 0)
+                return NFPROTO_IPV6;
+        else if (strcmp(str, "inet") == 0)
+                return NFPROTO_INET;
+        else {
+                fprintf(stderr, "Unknown %s: ip, ip6, inet\n", option);
+                exit(EXIT_FAILURE);
+        }
+}
+
+static uint8_t parse_l4proto(char *str)
+{
+        if (strcmp(str, "udp") == 0)
+                return IPPROTO_UDP;
+        else if (strcmp(str, "tcp") == 0)
+                return IPPROTO_TCP;
+        else {
+                fprintf(stderr, "Unknown l4proto: tcp, udp\n");
+                exit(EXIT_FAILURE);
+        }
+        return IPPROTO_TCP;
+}
+
+static struct nftnl_obj *ct_helper_add_parse(int argc, char *argv[])
+{
+        struct nftnl_obj *t;
+        uint16_t family, l3proto;
+        uint8_t l4proto;
+
+        t = nftnl_obj_alloc();
+        if (t == NULL) {
+                perror("OOM");
+                return NULL;
+        }
+
+        family = parse_family(argv[1], "family");
+        nftnl_obj_set_u32(t, NFTNL_OBJ_FAMILY, family);
+        nftnl_obj_set_u32(t, NFTNL_OBJ_TYPE, NFT_OBJECT_CT_HELPER);
+        nftnl_obj_set_str(t, NFTNL_OBJ_TABLE, argv[2]);
+        nftnl_obj_set_str(t, NFTNL_OBJ_NAME, argv[3]);
+
+        nftnl_obj_set_str(t, NFTNL_OBJ_CT_HELPER_NAME, argv[4]);
+        l4proto = parse_l4proto(argv[5]);
+        nftnl_obj_set_u8(t, NFTNL_OBJ_CT_HELPER_L4PROTO, l4proto);
+        if (argc == 7) {
+                l3proto = parse_family(argv[6], "l3proto");
+                nftnl_obj_set_u16(t, NFTNL_OBJ_CT_HELPER_L3PROTO, l3proto);
+        }
+
+        return t;
+}
+
+int main(int argc, char *argv[])
+{
+        struct nftnl_obj *t;
+        uint32_t seq, obj_seq, family, portid;
+        struct mnl_nlmsg_batch *batch;
+        char buf[MNL_SOCKET_BUFFER_SIZE];
+        struct nlmsghdr *nlh;
+        struct mnl_socket *nl;
+        int ret;
+
+        if (argc < 6) {
+                fprintf(stderr, "%s <family> <table> <name> <type> <l4proto> [l3proto]\n", argv[0]);
+                exit(EXIT_FAILURE);
+        }
+
+        t = ct_helper_add_parse(argc, argv);
+        if (t == NULL)
+                exit(EXIT_FAILURE);
+
+        seq = time(NULL);
+        batch = mnl_nlmsg_batch_start(buf, sizeof(buf));
+
+        nftnl_batch_begin(mnl_nlmsg_batch_current(batch), seq++);
+        mnl_nlmsg_batch_next(batch);
+
+        obj_seq = seq;
+        family = nftnl_obj_get_u32(t, NFTNL_OBJ_FAMILY);
+        nlh = nftnl_nlmsg_build_hdr(mnl_nlmsg_batch_current(batch),
+                                    NFT_MSG_NEWOBJ, family, NLM_F_CREATE | NLM_F_ACK, seq++);
+
+        nftnl_obj_nlmsg_build_payload(nlh, t);
+        nftnl_obj_free(t);
+        mnl_nlmsg_batch_next(batch);
+
+        nftnl_batch_end(mnl_nlmsg_batch_current(batch), seq++);
+        mnl_nlmsg_batch_next(batch);
+
+        nl = mnl_socket_open(NETLINK_NETFILTER);
+        if (nl == NULL) {
+                perror("mnl_socket_open");
+                exit(EXIT_FAILURE);
+        }
+
+        if (mnl_socket_bind(nl, 0, MNL_SOCKET_AUTOPID) < 0) {
+                perror("mnl_socket_bind");
+                exit(EXIT_FAILURE);
+        }
+        portid = mnl_socket_get_portid(nl);
+
+        if (mnl_socket_sendto(nl, mnl_nlmsg_batch_head(batch),
+                              mnl_nlmsg_batch_size(batch)) < 0) {
+                perror("mnl_socket_send");
+                exit(EXIT_FAILURE);
+        }
+
+        mnl_nlmsg_batch_stop(batch);
+
+        ret = mnl_socket_recvfrom(nl, buf, sizeof(buf));
+        while (ret > 0) {
+                ret = mnl_cb_run(buf, ret, obj_seq, portid, NULL, NULL);
+                if (ret <= 0) {
+                        break;
+                }
+                ret = mnl_socket_recvfrom(nl, buf, sizeof(buf));
+        }
+        if (ret == -1) {
+                perror("error");
+                exit(EXIT_FAILURE);
+        }
+        mnl_socket_close(nl);
+
+        return EXIT_SUCCESS;
+}
diff --git a/examples/nft-ct-helper-del.c b/examples/nft-ct-helper-del.c
new file mode 100644
index 0000000..fda3026
--- /dev/null
+++ b/examples/nft-ct-helper-del.c
@@ -0,0 +1,124 @@
+/*
+ * (C) 2012 by Pablo Neira Ayuso <pablo@netfilter.org>
+ *
+ * This program is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This software has been sponsored by Sophos Astaro <http://www.sophos.com>
+ */
+
+#include <stdlib.h>
+#include <time.h>
+#include <string.h>
+#include <netinet/in.h>
+
+#include <linux/netfilter.h>
+#include <linux/netfilter/nf_tables.h>
+
+#include <libmnl/libmnl.h>
+#include <libnftnl/object.h>
+
+static struct nftnl_obj *ct_helper_del_parse(int argc, char *argv[])
+{
+	struct nftnl_obj *t;
+	uint16_t family;
+
+	if (strcmp(argv[1], "ip") == 0)
+		family = NFPROTO_IPV4;
+	else if (strcmp(argv[1], "ip6") == 0)
+		family = NFPROTO_IPV6;
+	else if (strcmp(argv[1], "inet") == 0)
+		family = NFPROTO_INET;
+	else {
+		fprintf(stderr, "Unknown family: ip, ip6, inet\n");
+		return NULL;
+	}
+
+	t = nftnl_obj_alloc();
+	if (t == NULL) {
+		perror("OOM");
+		return NULL;
+	}
+
+	nftnl_obj_set_str(t, NFTNL_OBJ_TABLE, argv[2]);
+	nftnl_obj_set_str(t, NFTNL_OBJ_NAME, argv[3]);
+	nftnl_obj_set_u32(t, NFTNL_OBJ_TYPE, NFT_OBJECT_CT_HELPER);
+	nftnl_obj_set_u32(t, NFTNL_OBJ_FAMILY, family);
+
+	return t;
+}
+
+int main(int argc, char *argv[])
+{
+	struct mnl_socket *nl;
+	char buf[MNL_SOCKET_BUFFER_SIZE];
+	struct nlmsghdr *nlh;
+	uint32_t portid, seq, obj_seq, family;
+	struct nftnl_obj *t;
+	struct mnl_nlmsg_batch *batch;
+	int ret;
+
+	if (argc != 4) {
+		fprintf(stderr, "%s <family> <table> <name>\n", argv[0]);
+		exit(EXIT_FAILURE);
+	}
+
+	t = ct_helper_del_parse(argc, argv);
+	if (t == NULL)
+		exit(EXIT_FAILURE);
+
+	seq = time(NULL);
+	batch = mnl_nlmsg_batch_start(buf, sizeof(buf));
+
+	nftnl_batch_begin(mnl_nlmsg_batch_current(batch), seq++);
+	mnl_nlmsg_batch_next(batch);
+
+	obj_seq = seq;
+	family = nftnl_obj_get_u32(t, NFTNL_OBJ_FAMILY);
+	nlh = nftnl_nlmsg_build_hdr(mnl_nlmsg_batch_current(batch),
+				    NFT_MSG_DELOBJ, family, NLM_F_ACK,
+				    seq++);
+	nftnl_obj_nlmsg_build_payload(nlh, t);
+	mnl_nlmsg_batch_next(batch);
+	nftnl_obj_free(t);
+
+	nftnl_batch_end(mnl_nlmsg_batch_current(batch), seq++);
+	mnl_nlmsg_batch_next(batch);
+
+	nl = mnl_socket_open(NETLINK_NETFILTER);
+	if (nl == NULL) {
+		perror("mnl_socket_open");
+		exit(EXIT_FAILURE);
+	}
+
+	if (mnl_socket_bind(nl, 0, MNL_SOCKET_AUTOPID) < 0) {
+		perror("mnl_socket_bind");
+		exit(EXIT_FAILURE);
+	}
+	portid = mnl_socket_get_portid(nl);
+
+	if (mnl_socket_sendto(nl, mnl_nlmsg_batch_head(batch),
+			      mnl_nlmsg_batch_size(batch)) < 0) {
+		perror("mnl_socket_send");
+		exit(EXIT_FAILURE);
+	}
+
+	mnl_nlmsg_batch_stop(batch);
+
+	ret = mnl_socket_recvfrom(nl, buf, sizeof(buf));
+	while (ret > 0) {
+		ret = mnl_cb_run(buf, ret, obj_seq, portid, NULL, NULL);
+		if (ret <= 0)
+			break;
+		ret = mnl_socket_recvfrom(nl, buf, sizeof(buf));
+	}
+	if (ret == -1) {
+		perror("error");
+		exit(EXIT_FAILURE);
+	}
+	mnl_socket_close(nl);
+
+	return EXIT_SUCCESS;
+}
diff --git a/examples/nft-ct-helper-get.c b/examples/nft-ct-helper-get.c
new file mode 100644
index 0000000..94bd0cd
--- /dev/null
+++ b/examples/nft-ct-helper-get.c
@@ -0,0 +1,150 @@
+/*
+ * (C) 2012 by Pablo Neira Ayuso <pablo@netfilter.org>
+ *
+ * This program is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This software has been sponsored by Sophos Astaro <http://www.sophos.com>
+ */
+
+
+#include <stdlib.h>
+#include <time.h>
+#include <string.h>
+#include <netinet/in.h>
+
+#include <linux/netfilter.h>
+#include <linux/netfilter/nf_tables.h>
+
+#include <libmnl/libmnl.h>
+#include <libnftnl/object.h>
+
+static int obj_cb(const struct nlmsghdr *nlh, void *data)
+{
+	struct nftnl_obj *t;
+	char buf[4096];
+	uint32_t *type = data;
+
+	t = nftnl_obj_alloc();
+	if (t == NULL) {
+		perror("OOM");
+		goto err;
+	}
+
+	if (nftnl_obj_nlmsg_parse(nlh, t) < 0) {
+		perror("nftnl_obj_nlmsg_parse");
+		goto err_free;
+	}
+
+	nftnl_obj_snprintf(buf, sizeof(buf), t, *type, 0);
+	printf("%s\n", buf);
+
+err_free:
+	nftnl_obj_free(t);
+err:
+	return MNL_CB_OK;
+}
+
+int main(int argc, char *argv[])
+{
+	struct mnl_socket *nl;
+	char buf[MNL_SOCKET_BUFFER_SIZE];
+	struct nlmsghdr *nlh;
+	uint32_t portid, seq, family;
+	struct nftnl_obj *t = NULL;
+	int ret;
+	uint32_t type = NFTNL_OUTPUT_DEFAULT;
+
+	if (argc < 3 || argc > 5) {
+		fprintf(stderr, "%s <family> <table> [<obj>] [<default|xml|json>]\n",
+			argv[0]);
+		return EXIT_FAILURE;
+	}
+
+	if (strcmp(argv[1], "ip") == 0)
+		family = NFPROTO_IPV4;
+	else if (strcmp(argv[1], "ip6") == 0)
+		family = NFPROTO_IPV6;
+	else if (strcmp(argv[1], "inet") == 0)
+		family = NFPROTO_INET;
+	else if (strcmp(argv[1], "unspec") == 0)
+		family = NFPROTO_UNSPEC;
+	else {
+		fprintf(stderr, "Unknown family: ip, ip6, inet, unspec");
+		exit(EXIT_FAILURE);
+	}
+
+	if (strcmp(argv[argc-1], "xml") == 0) {
+		type = NFTNL_OUTPUT_XML;
+		argv[argc-1] = NULL;
+		argc--;
+	}else if (strcmp(argv[argc-1], "json") == 0) {
+		type = NFTNL_OUTPUT_JSON;
+		argv[argc-1] = NULL;
+		argc--;
+	} else if (strcmp(argv[argc - 1], "default") == 0) {
+		argc--;
+	}
+
+	if (argc == 3 || argc == 4) {
+		t = nftnl_obj_alloc();
+		if (t == NULL) {
+			perror("OOM");
+			exit(EXIT_FAILURE);
+		}
+	}
+
+	seq = time(NULL);
+        nftnl_obj_set_u32(t, NFTNL_OBJ_TYPE, NFT_OBJECT_CT_HELPER);
+	if (argc < 4) {
+		nlh = nftnl_nlmsg_build_hdr(buf, NFT_MSG_GETOBJ, family,
+					    NLM_F_DUMP, seq);
+		if (argc == 3) {
+			nftnl_obj_set(t, NFTNL_OBJ_TABLE, argv[2]);
+			nftnl_obj_nlmsg_build_payload(nlh, t);
+			nftnl_obj_free(t);
+		}
+	} else {
+		nftnl_obj_set(t, NFTNL_OBJ_TABLE, argv[2]);
+		nftnl_obj_set(t, NFTNL_OBJ_NAME, argv[3]);
+
+		nlh = nftnl_nlmsg_build_hdr(buf, NFT_MSG_GETOBJ, family,
+					    NLM_F_ACK, seq);
+		nftnl_obj_nlmsg_build_payload(nlh, t);
+		nftnl_obj_free(t);
+	}
+
+	nl = mnl_socket_open(NETLINK_NETFILTER);
+	if (nl == NULL) {
+		perror("mnl_socket_open");
+		exit(EXIT_FAILURE);
+	}
+
+	if (mnl_socket_bind(nl, 0, MNL_SOCKET_AUTOPID) < 0) {
+		perror("mnl_socket_bind");
+		exit(EXIT_FAILURE);
+	}
+	portid = mnl_socket_get_portid(nl);
+
+	if (mnl_socket_sendto(nl, nlh, nlh->nlmsg_len) < 0) {
+		perror("mnl_socket_send");
+		exit(EXIT_FAILURE);
+	}
+
+	ret = mnl_socket_recvfrom(nl, buf, sizeof(buf));
+	while (ret > 0) {
+		ret = mnl_cb_run(buf, ret, seq, portid, obj_cb, &type);
+		if (ret <= 0)
+			break;
+		ret = mnl_socket_recvfrom(nl, buf, sizeof(buf));
+	}
+	if (ret == -1) {
+		perror("error");
+		exit(EXIT_FAILURE);
+	}
+	mnl_socket_close(nl);
+
+	return EXIT_SUCCESS;
+}